

motorvib = {};

function motorvib.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end

function motorvib:load(savegame)
    self.motorVibActive = false;
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayKurs1 = 0;
    self.delayKurs2 = 0;
    self.delayOn = 0;
    self.delayOff = 0;
    self.deltafo = 0;

    local motorVibNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.motorVib#index"));
    if motorVibNode ~= nil then
        self.motorVib = {};
        self.motorVib.node = motorVibNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.motorVib#minRot"));
        self.motorVib.minRot = {};
        self.motorVib.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motorVib.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motorVib.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.motorVib#maxRot"));
        self.motorVib.maxRot = {};
        self.motorVib.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motorVib.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motorVib.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.motorVib.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.motorVib#rotTime"), 2)*70;
        self.motorVib.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.motorVib#touchRotLimit"), 10));
    end

    self.movingFlag = self:getNextDirtyFlag();

end

function motorvib:delete()
end

function motorvib:mouseEvent(posX, posY, isDown, isUp, button)
end

function motorvib:keyEvent(unicode, sym, modifier, isDown)
end

function motorvib:update(dt)    
    if self:getIsActive() and self.motorVibActive ~= nil and self.isMotorStarted then
        if self.delayKurs1 >= 0 then
            self.delayKurs1 = self.delayKurs1 -dt;
        end
        if self.delayKurs2 >= 0 then
            self.delayKurs2 = self.delayKurs2 -dt;
        end

        if not self.motorVibMax then
            if self.delayKurs1 < 0 then
                self.delayKurs2 = 70;
                self.motorVibMax = true;
            end
        end

        if self.motorVibMax then
            if self.delayKurs2 < 0 then
                self.delayKurs1 = 70;
                self.motorVibMax = false;
            end;
        end;
            
    else
        self.motorVibMax = false;
    end

    if self.motorVib ~= nil then
        local x, y, z = getRotation(self.motorVib.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.motorVib.maxRot, self.motorVib.minRot, 3, self.motorVib.rotTime, dt, not self.motorVibMax);
        setRotation(self.motorVib.node, unpack(newRot));
    end
end

function motorvib:draw()
end
